Package org.springframework.validation

# Interface Errors

All Known Subinterfaces:
  `BindingResult`

All Known Implementing Classes:
  `AbstractBindingResult`, `AbstractErrors`, `AbstractPropertyBindingResult`, `BeanPropertyBindingResult`, `BindException`, `DirectFieldBindingResult`, `MapBindingResult`, `ParameterErrors`, `SimpleErrors`

public interface Errors
Stores and exposes information about data-binding and validation errors for a specific object.

Field names are typically properties of the target object (for example, "name" when binding to a customer object). Implementations may also support nested fields in case of nested objects (for example, "address.street"), in conjunction with subtree navigation via `setNestedPath(java.lang.String)`: for example, an `AddressValidator` may validate "address", not being aware that this is a nested object of a top-level customer object.

Note: `Errors` objects are single-threaded.

Author:
  Rod Johnson, Juergen Hoeller
See Also:
  - `Validator`
  - `ValidationUtils`
  - `SimpleErrors`
  - `BindingResult`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`NESTED_PATH_SEPARATOR`
The separator between path elements in a nested path, for example in "customer.name" or "customer.address.street".

## Method Summary

Modifier and Type
Method
Description
`default void`
`addAllErrors(Errors errors)`
Add all errors from the given `Errors` instance to this `Errors` instance.
`default <T extends Throwable>
void`
`failOnError(Function<String,T> messageToException)`
Throw the mapped exception with a message summarizing the recorded errors.
`default List<ObjectError>`
`getAllErrors()`
Get all errors, both global and field ones.
`default int`
`getErrorCount()`
Determine the total number of errors.
`default FieldError`
`getFieldError()`
Get the first error associated with a field, if any.
`default FieldError`
`getFieldError(String field)`
Get the first error associated with the given field, if any.
`default int`
`getFieldErrorCount()`
Determine the number of errors associated with a field.
`default int`
`getFieldErrorCount(String field)`
Determine the number of errors associated with the given field.
`List<FieldError>`
`getFieldErrors()`
Get all errors associated with a field.
`default List<FieldError>`
`getFieldErrors(String field)`
Get all errors associated with the given field.
`default Class<?>`
`getFieldType(String field)`
Determine the type of the given field, as far as possible.
`Object`
`getFieldValue(String field)`
Return the current value of the given field, either the current bean property value or a rejected update from the last binding.
`default ObjectError`
`getGlobalError()`
Get the first global error, if any.
`default int`
`getGlobalErrorCount()`
Determine the number of global errors.
`List<ObjectError>`
`getGlobalErrors()`
Get all global errors.
`default String`
`getNestedPath()`
Return the current nested path of this `Errors` object.
`String`
`getObjectName()`
Return the name of the bound root object.
`default boolean`
`hasErrors()`
Determine if there were any errors.
`default boolean`
`hasFieldErrors()`
Determine if there were any errors associated with a field.
`default boolean`
`hasFieldErrors(String field)`
Determine if there were any errors associated with the given field.
`default boolean`
`hasGlobalErrors()`
Determine if there were any global errors.
`default void`
`popNestedPath()`
Pop the former nested path from the nested path stack.
`default void`
`pushNestedPath(String subPath)`
Push the given sub path onto the nested path stack.
`default void`
`reject(String errorCode)`
Register a global error for the entire target object, using the given error description.
`void`
`reject(String errorCode, Object[] errorArgs, String defaultMessage)`
Register a global error for the entire target object, using the given error description.
`default void`
`reject(String errorCode, String defaultMessage)`
Register a global error for the entire target object, using the given error description.
`default void`
`rejectValue(String field, String errorCode)`
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
`void`
`rejectValue(String field, String errorCode, Object[] errorArgs, String defaultMessage)`
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
`default void`
`rejectValue(String field, String errorCode, String defaultMessage)`
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
`default void`
`setNestedPath(String nestedPath)`
Allow context to be changed so that standard validators can validate subtrees.
`String`
`toString()`
Return a summary of the recorded errors, for example, for inclusion in an exception message.

## Field Details

### NESTED_PATH_SEPARATOR

static final String NESTED_PATH_SEPARATOR
The separator between path elements in a nested path, for example in "customer.name" or "customer.address.street".

"." = same as the `nested property separator` in the beans package.

See Also:
  - Constant Field Values

## Method Details

### getObjectName

String getObjectName()
Return the name of the bound root object.

### setNestedPath

default void setNestedPath(String nestedPath)
Allow context to be changed so that standard validators can validate subtrees. Reject calls prepend the given path to the field names.

For example, an address validator could validate the subobject "address" of a customer object.

The default implementation throws `UnsupportedOperationException` since not all `Errors` implementations support nested paths.

Parameters:
  `nestedPath` - nested path within this object, for example, "address" (defaults to "", `null` is also acceptable). Can end with a dot: both "address" and "address." are valid.
See Also:
  - `getNestedPath()`

### getNestedPath

default String getNestedPath()
Return the current nested path of this `Errors` object.

Returns a nested path with a dot, i.e. "address.", for easy building of concatenated paths. Default is an empty String.

See Also:
  - `setNestedPath(String)`

### pushNestedPath

default void pushNestedPath(String subPath)
Push the given sub path onto the nested path stack.

A `popNestedPath()` call will reset the original nested path before the corresponding `pushNestedPath(String)` call.

Using the nested path stack allows to set temporary nested paths for subobjects without having to worry about a temporary path holder.

For example: current path "spouse.", pushNestedPath("child") → result path "spouse.child."; popNestedPath() → "spouse." again.

The default implementation throws `UnsupportedOperationException` since not all `Errors` implementations support nested paths.

Parameters:
  `subPath` - the sub path to push onto the nested path stack
See Also:
  - `popNestedPath()`

### popNestedPath

default void popNestedPath() throws IllegalStateException
Pop the former nested path from the nested path stack.

Throws:
  `IllegalStateException` - if there is no former nested path on the stack
See Also:
  - `pushNestedPath(String)`

### reject

default void reject(String errorCode)
Register a global error for the entire target object, using the given error description.

Parameters:
  `errorCode` - error code, interpretable as a message key
See Also:
  - `reject(String, Object[], String)`

### reject

default void reject(String errorCode, String defaultMessage)
Register a global error for the entire target object, using the given error description.

Parameters:
  `errorCode` - error code, interpretable as a message key
  `defaultMessage` - fallback default message
See Also:
  - `reject(String, Object[], String)`

### reject

void reject(String errorCode, @Nullable Object[] errorArgs, @Nullable String defaultMessage)
Register a global error for the entire target object, using the given error description.

Parameters:
  `errorCode` - error code, interpretable as a message key
  `errorArgs` - error arguments, for argument binding via MessageFormat (can be `null`)
  `defaultMessage` - fallback default message
See Also:
  - `rejectValue(String, String, Object[], String)`

### rejectValue

default void rejectValue(@Nullable String field, String errorCode)
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

Parameters:
  `field` - the field name (may be `null` or empty String)
  `errorCode` - error code, interpretable as a message key
See Also:
  - `rejectValue(String, String, Object[], String)`

### rejectValue

default void rejectValue(@Nullable String field, String errorCode, String defaultMessage)
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

Parameters:
  `field` - the field name (may be `null` or empty String)
  `errorCode` - error code, interpretable as a message key
  `defaultMessage` - fallback default message
See Also:
  - `rejectValue(String, String, Object[], String)`

### rejectValue

void rejectValue(@Nullable String field, String errorCode, @Nullable Object[] errorArgs, @Nullable String defaultMessage)
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

Parameters:
  `field` - the field name (may be `null` or empty String)
  `errorCode` - error code, interpretable as a message key
  `errorArgs` - error arguments, for argument binding via MessageFormat (can be `null`)
  `defaultMessage` - fallback default message
See Also:
  - `reject(String, Object[], String)`

### addAllErrors

default void addAllErrors(Errors errors)
Add all errors from the given `Errors` instance to this `Errors` instance.

This is a convenience method to avoid repeated `reject(..)` calls for merging an `Errors` instance into another `Errors` instance.

Note that the passed-in `Errors` instance is supposed to refer to the same target object, or at least contain compatible errors that apply to the target object of this `Errors` instance.

The default implementation throws `UnsupportedOperationException` since not all `Errors` implementations support `#addAllErrors`.

Parameters:
  `errors` - the `Errors` instance to merge in
See Also:
  - `getAllErrors()`

### failOnError

default <T extends Throwable> void failOnError(Function<String,T> messageToException) throws T
Throw the mapped exception with a message summarizing the recorded errors.

Type Parameters:
  `T` - the exception type to be thrown
Parameters:
  `messageToException` - a function mapping the message to the exception, for example, `IllegalArgumentException::new` or `IllegalStateException::new`
Throws:
  `T extends Throwable`
Since:
  6.1
See Also:
  - `toString()`

### hasErrors

default boolean hasErrors()
Determine if there were any errors.

See Also:
  - `hasGlobalErrors()`
  - `hasFieldErrors()`

### getErrorCount

default int getErrorCount()
Determine the total number of errors.

See Also:
  - `getGlobalErrorCount()`
  - `getFieldErrorCount()`

### getAllErrors

default List<ObjectError> getAllErrors()
Get all errors, both global and field ones.

Returns:
  a list of `ObjectError`/`FieldError` instances
See Also:
  - `getGlobalErrors()`
  - `getFieldErrors()`

### hasGlobalErrors

default boolean hasGlobalErrors()
Determine if there were any global errors.

See Also:
  - `hasFieldErrors()`

### getGlobalErrorCount

default int getGlobalErrorCount()
Determine the number of global errors.

See Also:
  - `getFieldErrorCount()`

### getGlobalErrors

List<ObjectError> getGlobalErrors()
Get all global errors.

Returns:
  a list of `ObjectError` instances
See Also:
  - `getFieldErrors()`

### getGlobalError

@Nullable default ObjectError getGlobalError()
Get the first global error, if any.

Returns:
  the global error, or `null`
See Also:
  - `getFieldError()`

### hasFieldErrors

default boolean hasFieldErrors()
Determine if there were any errors associated with a field.

See Also:
  - `hasGlobalErrors()`

### getFieldErrorCount

default int getFieldErrorCount()
Determine the number of errors associated with a field.

See Also:
  - `getGlobalErrorCount()`

### getFieldErrors

List<FieldError> getFieldErrors()
Get all errors associated with a field.

Returns:
  a List of `FieldError` instances
See Also:
  - `getGlobalErrors()`

### getFieldError

@Nullable default FieldError getFieldError()
Get the first error associated with a field, if any.

Returns:
  the field-specific error, or `null`
See Also:
  - `getGlobalError()`

### hasFieldErrors

default boolean hasFieldErrors(String field)
Determine if there were any errors associated with the given field.

Parameters:
  `field` - the field name
See Also:
  - `hasFieldErrors()`

### getFieldErrorCount

default int getFieldErrorCount(String field)
Determine the number of errors associated with the given field.

Parameters:
  `field` - the field name
See Also:
  - `getFieldErrorCount()`

### getFieldErrors

default List<FieldError> getFieldErrors(String field)
Get all errors associated with the given field.

Implementations may support not only full field names like "address.street" but also pattern matches like "address.*".

Parameters:
  `field` - the field name
Returns:
  a List of `FieldError` instances
See Also:
  - `getFieldErrors()`

### getFieldError

@Nullable default FieldError getFieldError(String field)
Get the first error associated with the given field, if any.

Parameters:
  `field` - the field name
Returns:
  the field-specific error, or `null`
See Also:
  - `getFieldError()`

### getFieldValue

@Nullable Object getFieldValue(String field)
Return the current value of the given field, either the current bean property value or a rejected update from the last binding.

Allows for convenient access to user-specified field values, even if there were type mismatches.

Parameters:
  `field` - the field name
Returns:
  the current value of the given field
See Also:
  - `getFieldType(String)`

### getFieldType

@Nullable default Class<?> getFieldType(String field)
Determine the type of the given field, as far as possible.

Implementations should be able to determine the type even when the field value is `null`, for example from some associated descriptor.

Parameters:
  `field` - the field name
Returns:
  the type of the field, or `null` if not determinable
See Also:
  - `getFieldValue(String)`

### toString

String toString()
Return a summary of the recorded errors, for example, for inclusion in an exception message.

Overrides:
  `toString` in class `Object`
See Also:
  - `failOnError(Function)`